/*! \file models.cpp
 *  \brief Implementation of various Fourier-domain probabilistic models
 */

#include "models.h"

#define Matrix itpp::mat

FourierFunc *uniform_fourier(int n)
{
        FourierFunc *fc = new FourierFunc(n);
        Matrix trivial_coeff (1, 1);

        fc->parts.push_back(Partition(1, &n));

        trivial_coeff.set(0, 0, 1);
        fc->coeffs.push_back(trivial_coeff);

        return fc;
}
